package com.gx.obe.component.comparison;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.gx.obe.util.utils.Keys;

public class ComparisonData {
	
	private List<Column> headColList = new ArrayList<>();
	private List<Column> titleColList = new ArrayList<>();
	private List<Column> itemColList = new ArrayList<>();
	private List<String> rowList = new ArrayList<>();
	
	private Map<Keys, String> headContentMap = new HashMap<>();
	private Map<Keys, String> comparisonContentMap = new HashMap<>();
	
	public boolean addHeadCol(Column col) {
		return headColList.add(col);
	}
	
	public boolean addTitleCol(Column col) {
		return titleColList.add(col);
	}
	
	public boolean addItemCol(Column col) {
		return itemColList.add(col);
	}
	
	public boolean addRow(String row) {
		return rowList.add(row);
	}
	
	public String putHeadContent(String rowId, String headId, String value) {
		return headContentMap.put(Keys.of(rowId, headId), value);
	}
	
	public String putComparisonContent(String rowId, String titleId, String itemId, String value) {
		return comparisonContentMap.put(Keys.of(rowId, titleId, itemId), value);
	}
	
	public List<Column> getHeadColList() {
		return headColList;
	}
	
	public List<Column> getTitleColList() {
		return titleColList;
	}
	
	public List<Column> getItemColList() {
		return itemColList;
	}
	
	public List<String> getRowList() {
		return rowList;
	}
	
	public Map<Keys, String> getHeadContentMap() {
		return headContentMap;
	}
	
	public Map<Keys, String> getComparisonContentMap() {
		return comparisonContentMap;
	}
	
}
