package com.gx.obe.component.table;

import java.util.function.Function;

import org.eclipse.swt.graphics.Image;

import de.kupzog.ktable.SWTX;

/**
 * @Description: 列
 * @author chenxw
 */
public class Column {
	
	public static final int ALIGN_LEFT = SWTX.ALIGN_HORIZONTAL_LEFT;
	public static final int ALIGN_CENTER = SWTX.ALIGN_HORIZONTAL_CENTER;
	public static final int ALIGN_RIGHT = SWTX.ALIGN_HORIZONTAL_RIGHT;
	
	/**
	 * @Description: 名称
	 */
	private String name;
	/**
	 * @Description: 根据序号获取展示内容
	 */
	private Function<Integer, String> function;
	/**
	 * @Description: 图片
	 */
	private Image image;
	/**
	 * @Description: 对齐方式
	 */
	private Integer align;
	/**
	 * @Description: 最小列宽
	 */
	private Integer minWidth;
	/**
	 * @Description: 列宽
	 */
	private Integer width;
	/**
	 * @Description: 最大列宽
	 */
	private Integer maxWidth;
	
	/**
	 * @author chenxw
	 * @param name
	 * @param function
	 */
	public Column(String name, Function<Integer, String> function) {
		this.name = name;
		this.function = function;
	}
	
	public String getName() {
		return name;
	}
	
	public Function<Integer, String> getFunction() {
		return function;
	}
	
	public Column image(Image image) {
		this.image = image;
		return this;
	}
	
	public Image getImage() {
		return image;
	}
	
	public Column align(int align) {
		this.align = align;
		return this;
	}
	
	public Integer getAlign() {
		return align;
	}
	
	public Column minWidth(int minWidth) {
		this.minWidth = minWidth;
		return this;
	}
	
	public Integer getMinWidth() {
		return minWidth;
	}
	
	public Column width(int width) {
		this.width = width;
		return this;
	}
	
	public Integer getWidth() {
		return width;
	}
	
	public Column maxWidth(int maxWidth) {
		this.maxWidth = maxWidth;
		return this;
	}
	
	public Integer getMaxWidth() {
		return maxWidth;
	}
	
}