package com.gx.obe.component.tree;

import java.util.List;

/**
 * @Description: 树
 * @author chenxw
 */
public interface ITree<T extends ITree<T>> {
	
	/**
	 * @Description: 获取树根节点
	 * @author chenxw
	 * @return
	 */
	ITree<T> getRoot();
	
	/**
	 * @Description: 子树列表
	 * @author chenxw
	 * @return
	 */
	List<? extends T> getITrees();
	
	/**
	 * @Description: 名称
	 * @author chenxw
	 * @return
	 */
	String getName();
	
	/**
	 * @Description: 键
	 * @author chenxw
	 * @return
	 */
	String getKey();
	
	/**
	 * @Description: 值
	 * @author chenxw
	 * @param key
	 * @return
	 */
	String getValue(Object key);
	
}
