package com.gx.obe.component.utils;

import java.util.Arrays;
import java.util.Optional;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

public class CompositeUtils {
	
	public static void disposeChildren(Composite composite) {
		Arrays.stream(composite.getChildren()).forEach(Control::dispose);
	}
	
	public static void notifyMouseUp(Composite composite) {
		CompositeUtils.getFirst(composite).ifPresent(t -> t.notifyListeners(SWT.MouseUp, null));
	}
	
	public static Optional<Control> getFirst(Composite composite) {
		return Arrays.stream(composite.getChildren()).findFirst();
	}
	
}
