package com.gx.obe.component.verify;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.widgets.Control;

import com.gx.obe.bind.fun.Fun;

public class FormVerify {
	
	List<Data> datas = new ArrayList<>();
	
	public <T> void verify(Verify<T> verify, Function<T, Boolean> discontentCondition, String message) {
		datas.add(new Data(verify.getVerifyControl(), Fun.of(discontentCondition).toGet(verify::get), message));
	}
	
	public void verify(Control control, Supplier<Boolean> discontentCondition, String message) {
		datas.add(new Data(() -> control, discontentCondition, message));
	}
	
	public void add(FormVerify formVerify) {
		datas.addAll(formVerify.getDatas());
	}
	
	public boolean isFail() {
		for (Data data : datas) {
			if (data.discontentCondition.get()) {
				MessageDialog.openWarning(data.controlGet.get().getShell(), data.message);
				data.controlGet.get().setFocus();
				return true;
			}
		}
		return false;
	}
	
	private List<Data> getDatas() {
		return datas;
	}
	
	class Data {
		Supplier<Control> controlGet;
		Supplier<Boolean> discontentCondition;
		String message;
		
		public Data(Supplier<Control> controlGet, Supplier<Boolean> discontentCondition, String message) {
			this.controlGet = controlGet;
			this.discontentCondition = discontentCondition;
			this.message = message;
		}
		
	}
	
}
