package com.gx.obe.component.verify;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.widgets.Text;

/**
 * @Description: 整数验证监听
 * @author chenxw
 */
public class IntegerVerifyListener implements VerifyListener {
	
	private boolean negativeSupport;
	
	/**
	 * @author chenxw
	 * @param negativeSupport
	 */
	public IntegerVerifyListener(boolean negativeSupport) {
		this.negativeSupport = negativeSupport;
	}
	
	@Override
	public void verifyText(VerifyEvent event) {
		if (event.keyCode == SWT.BS || event.keyCode == SWT.DEL) {
			event.doit = true;
			return;
		}
		event.doit = false;
		char myChar = event.character;
		Text text = (Text) event.widget;
		String textStr = text.getText();
		if (myChar == '-') {
			if (negativeSupport) {
				if (textStr.indexOf("-") == -1) {
					if (event.start == 0) {
						event.doit = true;
					}
				}
			}
		} else {
			// 其余的只能输入数字
			if ((myChar >= '0' && myChar <= '9')) {
				event.doit = true;
			}
		}
	}
	
}
